package sun.security.util;

import java.security.GeneralSecurityException;
import java.io.File;
import java.net.URISyntaxException;
import sun.net.www.ParseUtil;
import java.net.URI;

public class PropertyExpander
{
    public PropertyExpander() {
    }
    
    public static String expand(String s) throws PropertyExpander.ExpandException {
        return expand(s, false);
    }
    
    public static String expand(String s, boolean b) throws PropertyExpander.ExpandException {
        if (s == null) {
            return null;
        }
        int i = s.indexOf("${", 0);
        if (i == -1) {
            return s;
        }
        StringBuffer sb = new StringBuffer(s.length());
        int length = s.length();
        int beginIndex = 0;
        while (i < length) {
            if (i > beginIndex) {
                sb.append(s.substring(beginIndex, i));
            }
            int index = i + 2;
            if (index < length && s.charAt(index) == '{') {
                index = s.indexOf("}}", index);
                if (index == -1 || index + 2 == length) {
                    sb.append(s.substring(i));
                    break;
                }
                ++index;
                sb.append(s.substring(i, index + 1));
            }
            else {
                while (index < length && s.charAt(index) != '}') {
                    ++index;
                }
                if (index == length) {
                    sb.append(s.substring(i, index));
                    break;
                }
                String substring = s.substring(i + 2, index);
                if (substring.equals("/")) {
                    sb.append(File.separatorChar);
                }
                else {
                    String s2 = System.getProperty(substring);
                    if (s2 != null) {
                        if (b) {
                            try {
                                if (sb.length() > 0 || !new URI(s2).isAbsolute()) {
                                    s2 = ParseUtil.encodePath(s2);
                                }
                            }
                            catch (URISyntaxException ex) {
                                s2 = ParseUtil.encodePath(s2);
                            }
                        }
                        sb.append(s2);
                    }
                    else {
                        throw new PropertyExpander.ExpandException("unable to expand property " + substring);
                    }
                }
            }
            beginIndex = index + 1;
            i = s.indexOf("${", beginIndex);
            if (i == -1) {
                if (beginIndex < length) {
                    sb.append(s.substring(beginIndex, length));
                    break;
                }
                break;
            }
            else {
                continue;
            }
        }
        return sb.toString();
    }
    
    public static class ExpandException extends GeneralSecurityException
    {
        private static final long serialVersionUID = -7941948581406161702L;
        
        public ExpandException(String msg) {
            super(msg);
        }
    }
}
